| kspaceFirstOrder3D-OMP 1.0 The C++ implementation of the k-wave toolbox for the time-domain simulation of acoustic wave fields in 3D

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Static Private Attributes
TRealMatrix Class Reference

The class for real matrices.

`#include <RealMatrix.h>`

Inheritance diagram for TRealMatrix:
[legend]
Collaboration diagram for TRealMatrix:
[legend]

List of all members.

## Public Member Functions
| TRealMatrix (struct TDimensionSizes DimensionSizes)
| Constructor.
virtual | ~TRealMatrix ()
| Destructor.
virtual void | ReadDataFromHDF5File (THDF5_File &HDF5_File, const char *MatrixName)
| Read data from the HDF5 file.
virtual void | WriteDataToHDF5File (THDF5_File &HDF5_File, const char *MatrixName, const int CompressionLevel)
| Write data into the HDF5 file.
float & | operator[] (const size_t &index)
| operator []
float & | GetElementFrom3D (const size_t X, const size_t Y, const size_t Z)
| Get element from 3D matrix.
## Protected Member Functions
virtual void | InitDimensions (struct TDimensionSizes DimensionSizes)
| Init dimension.
| TRealMatrix ()
| Default constructor is not allowed for public.
| TRealMatrix (const TRealMatrix &src)
| Copy constructor not allowed for public.
TRealMatrix & | operator= (const TRealMatrix &src)
| Operator = is not allowed for public.
## Static Private Attributes
static const size_t | ChunkSize_1D_4MB = 1048576
| Number of elements to get 4MB block of data.
static const size_t | ChunkSize_1D_1MB = 262144
| Number of elements to get 1MB block of data.
static const size_t | ChunkSize_1D_256KB = 65536
| Number of elements to get 256KB block of data.

## Detailed Description

Definition at line 46 of file RealMatrix.h.

## Constructor & Destructor Documentation

TRealMatrix::TRealMatrix | ( | struct TDimensionSizes | DimensionSizes | ) |

Constructor

Parameters:

  [in] | DimensionSizes | - Dimension sizes

Definition at line 58 of file RealMatrix.cpp.

Here is the call graph for this function:

## Member Function Documentation

float& TRealMatrix::GetElementFrom3D | ( | const size_t | X,
|  | const size_t | Y,
|  | const size_t | Z
| ) |  | `[inline]`

Parameters:

  X | - X dimension
  Y | - Y dimension
  Z | - Z dimension

Returns:
  an element

Definition at line 77 of file RealMatrix.h.

void TRealMatrix::InitDimensions | ( | struct TDimensionSizes | DimensionSizes | ) | `[protected, virtual]`

Set necessary dimensions and auxiliary variables

Parameters:

  DimensionSizes | - 3D Dimension sizes

Definition at line 146 of file RealMatrix.cpp.

Here is the caller graph for this function:

float& TRealMatrix::operator[] | ( | const size_t & | index | ) | `[inline]`

Parameters:

  index | - 1D index

Returns:
  an element

Definition at line 66 of file RealMatrix.h.

void TRealMatrix::ReadDataFromHDF5File | ( | THDF5_File & | HDF5_File,
|  | const char * | MatrixName
| ) |  | `[virtual]`

Read data data from HDF5 file

Exceptions:

  ios::failure | if error occurred

Parameters:

  [in] | HDF5_File | - HDF5 file
  [in] | MatrixName | - HDF5 dataset name

Reimplemented from TBaseMatrix.

Definition at line 75 of file RealMatrix.cpp.

Here is the call graph for this function:

void TRealMatrix::WriteDataToHDF5File | ( | THDF5_File & | HDF5_File,
|  | const char * | MatrixName,
|  | const int | CompressionLevel
| ) |  | `[virtual]`

Write data to HDF5 file

Exceptions:

  ios::failure | if an error occurred

Parameters:

  [in] | HDF5_File | - HDF5 file
  [in] | MatrixName | - HDF5 Matrix name
  [in] | CompressionLevel | - Compression level

Reimplemented from TBaseMatrix.

Definition at line 108 of file RealMatrix.cpp.

Here is the call graph for this function:

Here is the caller graph for this function:

The documentation for this class was generated from the following files:

- MatrixClasses/RealMatrix.h
- MatrixClasses/RealMatrix.cpp

All Classes Files Functions Variables Typedefs Enumerations